WDOGCTL(8)

NAME
wdogctl - Watchdog timer control utility

SYNOPSIS
wdogctl
wdogctl -d
wdogctl -e [-A] [-p seconds] timer
wdogctl -k [-A] [-p seconds] timer
wdogctl -t
wdogctl -u [-A] [-p seconds] timer
wdogctl -x [-A] [-p seconds] timer

DESCRIPTION
wdogctl is used to manipulate watchdog timers. A watchdog timer is a hardware or software timer that resets the system if it fails to make progress within a prescribed period. To prevent the system from being reset, something must refresh the timer to prevent it from expiring.

A hardware watchdog timer asserts system's hardware reset signal when it expires. A software watchdog timer calls the kernel's s normal reboot path.

The NetBSD kernel provides three modes in which watchdog timers may operate: kernel tickle mode, user tickle mode, and external tickle mode.

kernel tickle mode
    A timer in the kernel refreshes the watchdog timer. This ensures kernel threads can make progress within the period of the watchdog timer.

user tickle mode
    wdogctl runs in the background and refreshes the watchdog timer. This ensures user programs can make progress within the period of the watchdog timer.

    Note that user tickle mode must be used with caution; on a heavily loaded system, the timer may expire accidentally, even though user programs may be making (very slow) progress. A user-mode timer is disarmed (if possible) when the device is closed, unless the timer is activated with the -x option.

external tickle mode
    Similar to user tickle mode, except that the tickle must be done explicitly by a separate invocation of wdogctl -t. This allows users to determine the activity whose progress the watchdog timer checks.

In kernel and user tickle modes, an attempt is made to refresh the watchdog timer in one half the timer's configured period. For example, if the watchdog timer has a period of 30 seconds, a refresh attempt is made every 15 seconds.

If called without arguments, wdogctl will list the timers available on the system. When arming a watchdog timer, the timer argument is the name of the timer to arm.

Only one timer may be armed at a time; if an attempt is made to arm a timer when one is already armed, an error message will be displayed and no action will be taken.

The options are as follows:

-A  When arming a timer, this flag indicates that an audible alarm is to sound when the watchdog timer expires and resets the system. If the selected timer does not support an audible alarm, this option will be silently ignored.

-d  This flag disarms the currently active timer. Note that not all watchdog timers can be disabled once armed. If the selected timer can not be disabled, an error message will be displayed and the timer will remain armed.

-e  Arm timer in external tickle mode.

-k  Arm timer in kernel tickle mode.

-p period
    When arming a timer, this flag configures the timer period to period seconds. If the specified period is outside the timer's range, an error message will be displayed and no action will be taken.

-t  This flag tickles an external mode timer.

-u  Arm timer in user tickle mode.

-x  Arm timer in a modified user tickle mode: closing the device will not disarm the timer.

FILES

/dev/watchdog
    the system monitor watchdog timer device

SEE ALSO
acpiwdrt(4), evbarm/iopwdog(4), i386/elansc(4), i386/gcscpcib(4), i386/geodewdog(4), ipmi(4), itesio(4), pcweasel(4), pwdog(4), swwdog(4), x86/tco(4)

HISTORY
The wdogctl command first appeared in NetBSD 1.6.

AUTHORS
The wdogctl command and the NetBSD watchdog timer framework were written by Jason R. Thorpe <thorpej@zembu.com>, and contributed by Zembu Labs, Inc.